Bug 1413474 - Review Request: python-pycdlib - Pure Python library for ISO manipulation
Summary: Review Request: python-pycdlib - Pure Python library for ISO manipulation
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Julien Enselme
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-16 05:28 UTC by Chris Lalancette
Modified: 2018-08-09 17:36 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-08-09 17:36:30 UTC
Type: ---
jujens: fedora-review+


Attachments (Terms of Use)

Description Chris Lalancette 2017-01-16 05:28:47 UTC
Spec URL: https://clalance.fedorapeople.org/python-pycdlib.spec
SRPM URL: https://clalance.fedorapeople.org/python-pycdlib-1.0.0-1.fc25.src.rpm
Description: python-pycdlib is a pure Python library used to manipulate ISOs as defined in ISO9660.  It supports most of the common extensions to ISO9660, such as El Torito, Joliet, and Rock Ridge.  Eventually the "oz" package (already in Fedora) will come to depend on this library.

I've run through the basic package review guidelines for python packages here https://fedoraproject.org/wiki/Packaging:ReviewGuidelines#Package_Review_Process and here https://fedoraproject.org/wiki/Packaging:Python?rd=Packaging/Python.  I've also run this package through pylint, and all RPMs and SRPMs pass with exactly one exception, on the SRPM:

python-pycdlib.src: W: invalid-url Source0: http://github.com/clalancette/pycdlib/archive/pycdlib-1.0.0.tar.gz HTTP Error 404: Not Found

While that is true, the upstream project doesn't release packages called "pycdlib-<version>.tar.gz"; it only releases "<version>.tar.gz".  I think this is an acceptable warning, though if there is a way to fix this, I'd be glad to hear it.


Fedora Account System Username: clalance

Comment 1 fszymanski 2017-01-20 18:44:04 UTC
See: https://github.com/clalancette/pycdlib/pull/2

Comment 2 fszymanski 2017-01-21 08:41:27 UTC
1) When you set a tag Name, Version, Summary, URL, etc. a macro is created %{name}, %{summary}, %{url}, ...
The summary global is unnecessary.

2) Tests do not have to be part of the RPM package (or setup.py file) to be run.
The build requires (pytest, genisoimage, etc.) and the %check section is all you need.

%check
PYTHONPATH=$RPM_BUILD_ROOT%{python2_sitelib} py.test-%{python2_version} -v
PYTHONPATH=$RPM_BUILD_ROOT%{python3_sitelib} py.test-%{python3_version} -v

3) Ok.

Comment 3 Chris Lalancette 2017-02-01 00:10:15 UTC
(In reply to Filip Szymański from comment #2)
> 1) When you set a tag Name, Version, Summary, URL, etc. a macro is created
> %{name}, %{summary}, %{url}, ...
> The summary global is unnecessary.

Ah, I didn't realize that was the case.  OK, I'll take that part of the patch then.  Thanks.

> 
> 2) Tests do not have to be part of the RPM package (or setup.py file) to be
> run.
> The build requires (pytest, genisoimage, etc.) and the %check section is all
> you need.
> 
> %check
> PYTHONPATH=$RPM_BUILD_ROOT%{python2_sitelib} py.test-%{python2_version} -v
> PYTHONPATH=$RPM_BUILD_ROOT%{python3_sitelib} py.test-%{python3_version} -v

Hm, OK.  When I enabled those parts of the RPM, I got some errors:

Executing(%check): /bin/sh -e /var/tmp/rpm-tmp.wD5Kvc
+ umask 022
+ cd /home/clalancette/rpmbuild/BUILD
+ cd pycdlib-1.1.0
+ PYTHONPATH=/home/clalancette/rpmbuild/BUILDROOT/python-pycdlib-1.1.0-0.20170201000812git7204e8b.fc25.x86_64/usr/lib/python2.7/site-packages
+ py.test-2.7 -v
============================= test session starts ==============================
platform linux2 -- Python 2.7.13, pytest-2.9.2, py-1.4.32, pluggy-0.3.1 -- /usr/bin/python2
cachedir: .cache
rootdir: /home/clalancette/rpmbuild/BUILD/pycdlib-1.1.0, inifile: 
collected 0 items 

========================= no tests ran in 0.02 seconds =========================
error: Bad exit status from /var/tmp/rpm-tmp.wD5Kvc (%check)

I'm on Fedora 25, x86_64.  Any thoughts?

> 
> 3) Ok.

Cool.  Thanks for your work on this so far!

Comment 4 Chris Lalancette 2017-02-01 00:28:55 UTC
I got it.  I needed to include the tests as part of the MANIFEST so that they would make it into the dist package, so that the RPM could then reference them.  They seem to pass now.

This particular change is probably going to require that I do a new upstream release (at least, I think that's the easiest way to manage this).  I'm going to do that, and then update the packages for review here.

Comment 5 Chris Lalancette 2017-02-01 00:56:22 UTC
All right, I've now done another upstream release (1.1.0), and updated the SPEC, SRPM, and RPMs accordingly.  I also tried building them in mock this time to make sure I got all of the BuildRequires, and indeed, I found one more: syslinux.  So I think this should be ready to go, they are available here: 

Spec URL: https://clalance.fedorapeople.org/python-pycdlib.spec
SRPM URL: https://clalance.fedorapeople.org/python-pycdlib-1.1.0-1.fc25.src.rpm

Please give them another review when you have a chance.  Thanks!

Comment 6 VincentS 2017-03-07 11:36:06 UTC
Hello,
I'm not yet a packager, so this is an unofficial review.

REVIEW:

+ OK
- NA 
X ISSUE

+ Package meets naming and packaging guidelines.
+ Spec file matches base package name.
+ Spec has consistant macro usage.
+ Meets Packaging Guidelines.
+ License
+ License field in spec matches
+ License file included in package
+ Spec in American English
+ Spec is legible.
X Sources match upstream sha256sum:
$ sha256sum pycdlib-1.1.0.tar.gz rpmbuild/SOURCES/pycdlib-1.1.0.tar.gz 
ae0d2aa92dbb40849666f4bcdd9b2c89f1c4e38cdd42bcb9a89a9e9aab8f14f6  pycdlib-1.1.0.tar.gz
bd32606ded8d7bdd339d1024fd8a724342a1c0eb0d1c10625e144a467f9096a5  rpmbuild/SOURCES/pycdlib-1.1.0.tar.gz

- Package needs ExcludeArch
+ BuildRequires correct
- Spec handles locales/find_lang
- Package is relocatable and has a reason to be.
+ Package has %defattr and permissions on files is good.
+ Package is code or permissible content.
+ Doc subpackage needed/used.
+ Packages %doc files don't affect runtime.
- Headers/static libs in -devel subpackage.
- Spec has needed ldconfig in post and postun
- .pc files in -devel subpackage/requires pkgconfig
- .so files in -devel subpackage.
- -devel package Requires: %{name} = %{version}-%{release}
- .la files are removed.

- Package is a GUI app and has a .desktop file

+ Package compiles and builds on at least one arch.
+ Package has no duplicate files in %files.
+ Package doesn't own any directories other packages own.
+ Package owns all the directories it creates.
+ Rpmlint output:
$ rpmlint fedora_review/pycdlib/python-pycdlib.spec fedora_review/pycdlib/python-pycdlib-1.1.0-1.fc25.src.rpm /var/lib/mock/fedora-rawhide-x86_64/result/pycdlib-tools-1.1.0-1.fc27.noarch.rpm 
python-pycdlib.src: W: file-size-mismatch pycdlib-1.1.0.tar.gz = 127613, https://github.com/clalancette/pycdlib/archive/v1.1.0/pycdlib-1.1.0.tar.gz = 136340
2 packages and 1 specfiles checked; 0 errors, 1 warnings.

+ final provides and requires are sane.


SHOULD Items:

+ Should build in mock.
+ Should build on all supported archs
+ Should function as described.
- Should have sane scriptlets.
- Should have subpackages require base package with fully versioned depend.
+ Should have dist tag
+ Should package latest version

Issues:

1. Sources doesn't match with upstream. 

You should verify your sources and rebuild the package with upstream sources.
By the way, I think it could be great to plan a porting to Python3.

Comment 7 Chris Lalancette 2017-03-09 01:30:58 UTC
It's odd that it doesn't match the upstream sha256 sum, since I created the release just for this review.  I'll take a look and see what happened there.

By the way, pycdlib already supports python3, and this package actually exports both a python2-pycdlib and a python3-pycdlib.  So we are good there.

Thanks for the review!

Comment 8 Chris Lalancette 2017-03-09 01:39:53 UTC
All right, I uploaded another version (with the same version number), but this one has the right sha256sum.  Please take another look when you have a chance, thanks.

Comment 9 VincentS 2017-03-09 08:14:54 UTC
Ok, I checked, now they match:
sha256sum pycdlib-1.1.0.tar.gz rpmbuild/SOURCES/pycdlib-1.1.0.tar.gz 
ae0d2aa92dbb40849666f4bcdd9b2c89f1c4e38cdd42bcb9a89a9e9aab8f14f6  pycdlib-1.1.0.tar.gz
ae0d2aa92dbb40849666f4bcdd9b2c89f1c4e38cdd42bcb9a89a9e9aab8f14f6  rpmbuild/SOURCES/pycdlib-1.1.0.tar.gz

Sorry, it's true, there is already Python3 support.

Your package seems ok for me.

PS: Please pay attention to the files versions.

Comment 10 Julien Enselme 2017-06-15 18:32:35 UTC
- Missing requires: python3-sendfile on the Python 3 package
- Are the tools python2 only?
- Missing COPYING in the tools subpackage
- I believe RPM lints errors are false positive due to this change: https://fedoraproject.org/wiki/Changes/python3_c.utf-8_locale


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[X]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[X]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v2.1)", "Unknown or generated". 27 files have unknown
     license. Detailed output of licensecheck in /tmp/1413474-python-
     pycdlib/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[X]: Package contains no bundled libraries without FPC exception.
[X]: Changelog in prescribed format.
[X]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[X]: Package uses nothing in %doc for runtime.
[X]: Package consistently uses macros (instead of hard-coded directory
     names).
[X]: Package is named according to the Package Naming Guidelines.
[X]: Package does not generate any conflict.
[X]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
[X]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[X]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 10 files.
[X]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[X]: Python eggs must not download any dependencies during the build
     process.
[X]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[X]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-pycdlib , python3-pycdlib , pycdlib-tools
[?]: Package functions as described.
[X]: Latest version is packaged.
[X]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[X]: %check is present and all tests pass.
[X]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-pycdlib-1.1.0-1.fc27.noarch.rpm
          python3-pycdlib-1.1.0-1.fc27.noarch.rpm
          pycdlib-tools-1.1.0-1.fc27.noarch.rpm
          python-pycdlib-1.1.0-1.fc27.src.rpm
python-pycdlib.src: E: specfile-error Python runtime initialized with LC_CTYPE=C (a locale with default ASCII encoding), which may cause Unicode compatibility problems. Using C.UTF-8, C.utf8, or UTF-8 (if available) as alternative Unicode-compatible locales is recommended.
python-pycdlib.src: E: specfile-error Python runtime initialized with LC_CTYPE=C (a locale with default ASCII encoding), which may cause Unicode compatibility problems. Using C.UTF-8, C.utf8, or UTF-8 (if available) as alternative Unicode-compatible locales is recommended.
4 packages and 0 specfiles checked; 2 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
3 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
python2-pycdlib (rpmlib, GLIBC filtered):
    python(abi)
    python2-pysendfile

pycdlib-tools (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python2-matplotlib
    python2-networkx
    python2-pycdlib

python3-pycdlib (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python2-pycdlib:
    python-pycdlib
    python2-pycdlib
    python2.7dist(pycdlib)
    python2dist(pycdlib)

pycdlib-tools:
    pycdlib-tools

python3-pycdlib:
    python3-pycdlib
    python3.6dist(pycdlib)
    python3dist(pycdlib)



Source checksums
----------------
https://github.com/clalancette/pycdlib/archive/v1.1.0/pycdlib-1.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : ae0d2aa92dbb40849666f4bcdd9b2c89f1c4e38cdd42bcb9a89a9e9aab8f14f6
  CHECKSUM(SHA256) upstream package : ae0d2aa92dbb40849666f4bcdd9b2c89f1c4e38cdd42bcb9a89a9e9aab8f14f6


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1413474
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 11 Chris Lalancette 2017-06-21 01:03:10 UTC
(In reply to Julien Enselme from comment #10)
> - Missing requires: python3-sendfile on the Python 3 package

Good call, I'll fix that.

> - Are the tools python2 only?

Right now, yes.

> - Missing COPYING in the tools subpackage

Sure, I'll fix that.

> - I believe RPM lints errors are false positive due to this change:
> https://fedoraproject.org/wiki/Changes/python3_c.utf-8_locale

Ah, I don't see those on F-25.  But if you think they are a false positive, I'll just leave it alone :).

I've uploaded a new version of the RPMS to the same location:

Spec URL: https://clalance.fedorapeople.org/python-pycdlib.spec
SRPM URL: https://clalance.fedorapeople.org/python-pycdlib-1.1.0-1.fc25.src.rpm

Let me know if there is anything else I should fix.  Thanks for the review, it is appreciated!

Comment 12 Julien Enselme 2017-06-21 19:10:08 UTC
I think you should be more precise in your %files section and transform %{python3_sitelib}/* into %{python3_sitelib}/%{srcname}/ and add %{python3_sitelib}/%{srcname}-%{version}-py%{python3-version}.egg-info/ You should do the same for python 2. I didn't pay attention to that during my initial review.

Comment 13 Chris Lalancette 2017-06-22 02:14:23 UTC
(In reply to Julien Enselme from comment #12)
> I think you should be more precise in your %files section and transform
> %{python3_sitelib}/* into %{python3_sitelib}/%{srcname}/ and add
> %{python3_sitelib}/%{srcname}-%{version}-py%{python3-version}.egg-info/ You
> should do the same for python 2. I didn't pay attention to that during my
> initial review.

Done now.  I've uploaded it to the same place.

Comment 14 Julien Enselme 2017-06-22 16:56:38 UTC
Looks good. Approved.

Comment 15 Chris Lalancette 2017-06-23 03:35:16 UTC
Excellent, thanks so much.  I've opened up a new package request in pkgdb now.

Comment 16 Gwyn Ciesla 2017-06-23 12:18:49 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/python-pycdlib

Comment 17 Chris Lalancette 2017-06-25 00:22:24 UTC
Thanks.

I was able to clone the repository (fedpkg clone), and then when I tried to import the srpm (fedpkg import /path/to/srpm), I'm getting:

Could not execute new_sources: Request is unauthorized.

I *think* I have permissions (at least pkgdb says that I do), and I think my account is up-to-date, but I'm not sure.  What can we do here?

Comment 18 Julien Enselme 2017-06-25 08:54:31 UTC
I think you can.

- Check it works ok for other repo
- Send a mail to devel to explain your problem.

Comment 19 Chris Lalancette 2017-06-25 13:13:24 UTC
I shouldn't try to do this stuff on Saturday night :).  I had forgotten to re-kinit, which is why I was getting denied.  I've got it now; thanks!


Note You need to log in before you can comment on or make changes to this bug.